<?php

foreach($GLOBALS["argv"] as $key => $value) {
	$pair = explode("=", $value);
	if (count($pair) == 2) {
		$pair[1] = trim($pair[1], "\"");
		$input[$pair[0]] = $pair[1];
	}
}

//print_r($input);

/*

--stats
Number of files: 24944
Number of files transferred: 247
Total file size: 1995190469 bytes
Total transferred file size: 21335068 bytes
Literal data: 21335068 bytes
Matched data: 0 bytes
File list size: 600345
File list generation time: 2.503 seconds
File list transfer time: 0.000 seconds
Total bytes sent: 3894084
Total bytes received: 5700

*/
//print(date("F d Y H:i:s.", strtotime("-1 days")));
//exit;

function clean_directory ($days, $directory) {
	if ($handle = opendir($directory)) {
		while (($file = readdir($handle)) !== false) {
			if (($file != '.') && ($file != '..')) {
				$path = "$directory/$file";
				//print("$path\n");
				
				if (is_dir($path) && eregi("^backup-[0-9]+-[0-9]+-[0-9]+\([0-9]+:[0-9]+:[0-9]+\)$", $file)) {
					if (filemtime($path) < @strtotime("-$days days")) {
						$date = @date("F d Y H:i:s.", filemtime($path));
						print("DELETE $path ($date)\n");
						exec("rm -R \"$path\"");
					} else {
						clean_directory($days, $path);
					}
				}
			}
		}
		closedir($handle);
	}
}

// Write a line to the backup log
function update_log ($path) {
	if ($handle = fopen($path, "a+")) {
		$date = @date("F d Y H:i:s.", time());
		fwrite($handle, "Backup performed at $date\n");
		fclose($handle);
	}
}

// Clean Directory
if (isset($input["days"])) {
	$dir = $input["dir"];
	$days = $input["days"];
	print("Cleaning archives older than $days day(s) old in $dir...\n");
	clean_directory($input["days"], $input["dir"]);
}

// Update Log
if (isset($input["log"])) update_log($input["log"]);

?>